Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.netlib.lapack
Class SLARRE

    java.lang.Object
      org.netlib.lapack.SLARRE

    public class SLARRE

extends java.lang.Object

    SLARRE is a simplified interface to the JLAPACK routine slarre.
    This interface converts Java-style 2D row-major arrays into
    the 1D column-major linearized arrays expected by the lower
    level JLAPACK routines.  Using this interface also allows you
    to omit offset and leading dimension arguments.  However, because
    of these conversions, these routines will be slower than the low
    level ones.  Following is the description from the original Fortran
    source.  Contact seymour@cs.utk.edu with any questions.

     *     ..
     *
     *  Purpose
     *  =======
     *
     *  To find the desired eigenvalues of a given real symmetric
     *  tridiagonal matrix T, SLARRE sets any "small" off-diagonal
     *  elements to zero, and for each unreduced block T_i, it finds
     *  (a) a suitable shift at one end of the block's spectrum,
     *  (b) the base representation, T_i - sigma_i I = L_i D_i L_i^T, and
     *  (c) eigenvalues of each L_i D_i L_i^T.
     *  The representations and eigenvalues found are then used by
     *  SSTEMR to compute the eigenvectors of T.
     *  The accuracy varies depending on whether bisection is used to
     *  find a few eigenvalues or the dqds algorithm (subroutine SLASQ2) to
     *  conpute all and then discard any unwanted one.
     *  As an added benefit, SLARRE also outputs the n
     *  Gerschgorin intervals for the matrices L_i D_i L_i^T.
     *
     *  Arguments
     *  =========
     *
     *  RANGE   (input) CHARACTER
     *          = 'A': ("All")   all eigenvalues will be found.
     *          = 'V': ("Value") all eigenvalues in the half-open interval
     *                           (VL, VU] will be found.
     *          = 'I': ("Index") the IL-th through IU-th eigenvalues (of the

     *                           entire matrix) will be found.
     *
     *  N       (input) INTEGER
     *          The order of the matrix. N > 0.
     *
     *  VL      (input/output) REAL
     *  VU      (input/output) REAL
     *          If RANGE='V', the lower and upper bounds for the eigenvalues.
     *          Eigenvalues less than or equal to VL, or greater than VU,
     *          will not be returned.  VL < VU.
     *          If RANGE='I' or ='A', SLARRE computes bounds on the desired
     *          part of the spectrum.
     *
     *  IL      (input) INTEGER
     *  IU      (input) INTEGER
     *          If RANGE='I', the indices (in ascending order) of the
     *          smallest and largest eigenvalues to be returned.
     *          1 <= IL <= IU <= N.
     *
     *  D       (input/output) REAL             array, dimension (N)
     *          On entry, the N diagonal elements of the tridiagonal
     *          matrix T.
     *          On exit, the N diagonal elements of the diagonal
     *          matrices D_i.
     *
     *  E       (input/output) REAL             array, dimension (N)
     *          On entry, the first (N-1) entries contain the subdiagonal
     *          elements of the tridiagonal matrix T; E(N) need not be set.
     *          On exit, E contains the subdiagonal elements of the unit
     *          bidiagonal matrices L_i. The entries E( ISPLIT( I ) ),
     *          1 <= I <= NSPLIT, contain the base points sigma_i on output.

     *
     *  E2      (input/output) REAL             array, dimension (N)
     *          On entry, the first (N-1) entries contain the SQUARES of the

     *          subdiagonal elements of the tridiagonal matrix T;
     *          E2(N) need not be set.
     *          On exit, the entries E2( ISPLIT( I ) ),
     *          1 <= I <= NSPLIT, have been set to zero
     *
     *  RTOL1   (input) REAL
     *  RTOL2   (input) REAL
     *           Parameters for bisection.
     *           An interval [LEFT,RIGHT] has converged if
     *           RIGHT-LEFT.LT.MAX( RTOL1*GAP, RTOL2*MAX(|LEFT|,|RIGHT|) )
     *
     *  SPLTOL (input) REAL
     *          The threshold for splitting.
     *
     *  NSPLIT  (output) INTEGER
     *          The number of blocks T splits into. 1 <= NSPLIT <= N.
     *
     *  ISPLIT  (output) INTEGER array, dimension (N)
     *          The splitting points, at which T breaks up into blocks.
     *          The first block consists of rows/columns 1 to ISPLIT(1),
     *          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
     *          etc., and the NSPLIT-th consists of rows/columns
     *          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
     *
     *  M       (output) INTEGER
     *          The total number of eigenvalues (of all L_i D_i L_i^T)
     *          found.
     *
     *  W       (output) REAL             array, dimension (N)
     *          The first M elements contain the eigenvalues. The
     *          eigenvalues of each of the blocks, L_i D_i L_i^T, are
     *          sorted in ascending order ( SLARRE may use the
     *          remaining N-M elements as workspace).
     *
     *  WERR    (output) REAL             array, dimension (N)
     *          The error bound on the corresponding eigenvalue in W.
     *
     *  WGAP    (output) REAL             array, dimension (N)
     *          The separation from the right neighbor eigenvalue in W.
     *          The gap is only with respect to the eigenvalues of the same b
     *          as each block has its own representation tree.
     *          Exception: at the right end of a block we store the left gap

     *
     *  IBLOCK  (output) INTEGER array, dimension (N)
     *          The indices of the blocks (submatrices) associated with the
     *          corresponding eigenvalues in W; IBLOCK(i)=1 if eigenvalue
     *          W(i) belongs to the first block from the top, =2 if W(i)
     *          belongs to the second block, etc.
     *
     *  INDEXW  (output) INTEGER array, dimension (N)
     *          The indices of the eigenvalues within each block (submatrix);
     *          for example, INDEXW(i)= 10 and IBLOCK(i)=2 imply that the
     *          i-th eigenvalue W(i) is the 10-th eigenvalue in block 2
     *
     *  GERS    (output) REAL             array, dimension (2*N)
     *          The N Gerschgorin intervals (the i-th Gerschgorin interval
     *          is (GERS(2*i-1), GERS(2*i)).
     *
     *  PIVMIN  (output) DOUBLE PRECISION
     *          The minimum pivot in the Sturm sequence for T.
     *
     *  WORK    (workspace) REAL             array, dimension (6*N)
     *          Workspace.
     *
     *  IWORK   (workspace) INTEGER array, dimension (5*N)
     *          Workspace.
     *
     *  INFO    (output) INTEGER
     *          = 0:  successful exit
     *          > 0:  A problem occured in SLARRE.
     *          < 0:  One of the called subroutines signaled an internal prob
     *                Needs inspection of the corresponding parameter IINFO
     *                for further information.
     *
     *          =-1:  Problem in SLARRD.
     *          = 2:  No base representation could be found in MAXTRY iterati
     *                Increasing MAXTRY and recompilation might be a remedy.

     *          =-3:  Problem in SLARRB when computing the refined root
     *                representation for SLASQ2.
     *          =-4:  Problem in SLARRB when preforming bisection on the
     *                desired part of the spectrum.
     *          =-5:  Problem in SLASQ2.
     *          =-6:  Problem in SLASQ2.
     *
     *  Further Details
     *  The base representations are required to suffer very little
     *  element growth and consequently define all their eigenvalues to
     *  high relative accuracy.
     *  ===============
     *
     *  Based on contributions by
     *     Beresford Parlett, University of California, Berkeley, USA
     *     Jim Demmel, University of California, Berkeley, USA
     *     Inderjit Dhillon, University of Texas, Austin, USA
     *     Osni Marques, LBNL/NERSC, USA
     *     Christof Voemel, University of California, Berkeley, USA
     *
     *  =====================================================================
     *
     *     .. Parameters ..

Constructor Summary
`SLARRE()`

Method Summary
`static void` | `SLARRE(java.lang.String range, int n, floatW vl, floatW vu, int il, int iu, float[] d, float[] e, float[] e2, float rtol1, float rtol2, float spltol, intW nsplit, int[] isplit, intW m, float[] w, float[] werr, float[] wgap, int[] iblock, int[] indexw, float[] gers, floatW pivmin, float[] work, int[] iwork, intW info)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SLARRE

    public SLARRE()

Method Detail

### SLARRE

    public static void SLARRE(java.lang.String range,
                              int n,
                              floatW vl,
                              floatW vu,
                              int il,
                              int iu,
                              float[] d,
                              float[] e,
                              float[] e2,
                              float rtol1,
                              float rtol2,
                              float spltol,
                              intW nsplit,
                              int[] isplit,
                              intW m,
                              float[] w,
                              float[] werr,
                              float[] wgap,
                              int[] iblock,
                              int[] indexw,
                              float[] gers,
                              floatW pivmin,
                              float[] work,
                              int[] iwork,
                              intW info)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD